<template>
  <div class="md-layout Snippet md-gutter md-alignment-center">
    <h2 class="md-layout-item md-size-100">Snippet</h2>

    <md-card v-if="!$route.params.id" v-for="snippet in snippets" :key="snippet.id" class="md-layout-item blog-card">
      <md-card-area>
        <md-card-header>
          <div @click="openSnippet(snippet)" class="md-title md-primary">{{ snippet.title }}</div>
          <a :href="snippet.highlight">html</a>
        </md-card-header>
      </md-card-area>

      <md-card-actions>
        <md-button @click="openSnippet(snippet)" class="md-icon-button md-accent">
          <md-icon>favorite</md-icon>
        </md-button>
      </md-card-actions>
    </md-card>

    <iframe v-if="snippet" :src="snippet.highlight"></iframe>
  </div>
</template>

<script>
  import { mapGetters } from 'vuex'

  export default {
    name: 'Snippet',
    mounted () {
      this.getData()
    },
    components: {},
    data () {
      return {
        snippets: [],
        nextPage: null,
        prevPage: null,
        snippet: this.$store.state.snippet,
        errors: [],
        copy: '© a.Signz 18'
      }
    },
    computed: {
      ...mapGetters([
        'api'
      ])
    },
    methods: {
      getData () {
        this.api.get('snippets/')
          .then(response => {
            // JSON responses are automatically parsed.
            this.snippets = response.data.results
            this.nextPage = response.data.next
            this.prevPage = response.data.previous
          })
          .catch(e => {
            this.errors.push(e)
            console.log(e)
          })
      },
      getSnippet (id) {
        this.api.get('snippets/' + id + '/html/')
          .then(response => {
            // JSON responses are automatically parsed.
            this.snippet = response.data
            this.$router.push({name: 'Snippet', params: {id: id}})
          })
          .catch(e => {
            this.errors.push(e)
            console.log(e)
          })
      },
      openSnippet (snippet) {
        this.snippet = snippet
        // this.getSnippet(snippet.id)
      }
    }
  }
</script>
